/*^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
-- EasyPlayer, EYP, Ralph Debusmann 1997-9
*/

OPT MODULE
OPT EXPORT

MODULE '*modules/listv'

OBJECT playlist
	dirlist:PTR TO listv
	filelist:PTR TO listv
ENDOBJECT

PROC playlist() OF playlist
	NEW self.dirlist.stringnode()
	NEW self.filelist.stringnode()
ENDPROC

PROC end() OF playlist
	END self.filelist
	END self.dirlist
ENDPROC

PROC prev() OF playlist
	self.dirlist.prev()
ENDPROC self.filelist.prev()

PROC succ() OF playlist
	self.dirlist.succ()
ENDPROC self.filelist.succ()

PROC addr() OF playlist IS self.filelist.addr()

PROC del() OF playlist
	self.dirlist.del()
ENDPROC self.filelist.del()

PROC item(n) OF playlist
	self.dirlist.item(n)
ENDPROC self.filelist.item(n)

PROC clear() OF playlist
	self.dirlist.clear()
	self.filelist.clear()
ENDPROC

PROC add(dir:PTR TO CHAR,file:PTR TO CHAR) OF playlist
	self.dirlist.add(dir)
	self.filelist.add(file)
ENDPROC

PROC pos() OF playlist IS self.filelist.pos()

PROC numitems() OF playlist IS self.filelist.numitems()

PROC first() OF playlist
	self.dirlist.first()
ENDPROC self.filelist.first()

PROC last() OF playlist
	self.dirlist.last()
ENDPROC self.filelist.last()

PROC moveitemfirst() OF playlist
	self.dirlist.moveitemfirst()
ENDPROC self.filelist.moveitemfirst()

PROC moveitemlast() OF playlist
	self.dirlist.moveitemlast()
ENDPROC self.filelist.moveitemlast()

PROC moveitemup() OF playlist
	self.dirlist.moveitemup()
ENDPROC self.filelist.moveitemup()

PROC moveitemdown() OF playlist
	self.dirlist.moveitemdown()
ENDPROC self.filelist.moveitemdown()
